

Module Timers
	
	' ----------------------------------------------------------------------  PERFORMANCE COUNTER - DECLARES
    Private frequency As Int64 = 0
    Private tStart As Int64
    Private tStop As Int64

    Private tMainLoopStart As Int64

    Private tStartWait As Int64
    Private tEndWait As Int64

    Private NewTimePhysics As Double
    Private OldTimePhysics As Double
    Private NewTimeRender As Double
    Private OldTimeRender As Double
    Private NewFpsRender As Double
    Private OldFpsRender As Double
    Private NewTimeTotal As Double
    Private OldTimeTotal As Double
    Private NewTimeLoop As Double
    Private OldTimeLoop As Double

    Private newTime(10) As Double
    Private oldTime(10) As Double

    Friend k_FPS As Single
    Friend k_FPS2 As Single
    Friend k_TIME As Single
    Friend StopRender As Boolean = False

    Private Const LoopTime As Single = 0.0334 ' 0.04 



    ' ##############################################################################################
    ' ########
    ' ########      PERFORMANCE COUNTER - TIMER FUNCTIONS
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################

    ' --------------------------------------------------------------------------- INIT TIMERS
    Private Sub InitTimers()
        QueryPerformanceFrequency(frequency)
    End Sub


    ' --------------------------------------------------------------------------- INIT START TIME
    Private Sub InitStartTime()
        QueryPerformanceCounter(tMainLoopStart)
    End Sub

    ' --------------------------------------------------------------------------- GET TIME PHYSICS
    Private Sub GetTimePhysics()
        QueryPerformanceCounter(tStop)
        NewTimePhysics = (tStop - tMainLoopStart) / frequency
    End Sub

    ' --------------------------------------------------------------------------- GET TIME RENDER
    Private Sub GetTimeRender()
        QueryPerformanceCounter(tStop)
        NewTimeRender = (tStop - tMainLoopStart) / frequency
    End Sub

    ' --------------------------------------------------------------------------- GET TIME TOTAL
    Private Sub GetTimeTotal()
        QueryPerformanceCounter(tStop)
        NewTimeTotal = (tStop - tMainLoopStart) / frequency
    End Sub

    ' --------------------------------------------------------------------------- GET TIME LOOP
    Private Sub GetTimeLoop()
        QueryPerformanceCounter(tStop)
        NewTimeLoop = (tStop - tMainLoopStart) / frequency
        If NewTimeLoop < 0 Then NewTimeLoop = 1
    End Sub









    ' ##############################################################################################
    ' ########
    ' ########      RENDER TIMING FUNCTIONS
    ' ########
    ' ##############################################################################################
    ' ##############################################################################################
    ' ##############################################################################################


    ' --------------------------------------------------------------------------- PREPARE TIMERS FOR START
    Friend Sub PrepareTimersForStart()
        If frequency <> 0 Then Return
        InitTimers()
        k_FPS = 25
        k_TIME = 1 / k_FPS
    End Sub



    ' --------------------------------------------------------------------------- EXEC FROM TIMER (MODIFICATA PER NET)
    Friend Sub ExecFromTimer()
        PrepareTimersForStart()

        GetTimeTotal()
        GetTimeLoop()

        Do While NewTimeLoop < LoopTime - 0.011 And Not StopRender
            System.Threading.Thread.Sleep(1)
            GetTimeLoop()
        Loop

        Do While NewTimeLoop < LoopTime And Not StopRender
            GetTimeLoop()
        Loop

        InitStartTime()

        Bullet_Step(CSng(NewTimeLoop))

        GetTimePhysics()

        DX_Step()


        ' TODO test this or remove 
        ' ------------------------------------ 
        'If Bullet_UseThreads Then
        '    System.Threading.Thread.Sleep(0)
        'End If
        ' ------------------------------------

        GetTimeRender()
        CalcTimes()

        If DEBUG_ViewMainParams Then
            PrintFPS()
        End If

        'Debug.Print DX8_InfoTimeString()
    End Sub



    ' --------------------------------------------------------------------------- CALC TIMES
    Private Sub CalcTimes()
        Dim delta As Double

        delta = NewTimeRender - OldTimeRender
        If System.Math.Abs(delta) > 0.01 Then
            OldTimeRender = NewTimeRender
        Else
            OldTimeRender = OldTimeRender + delta / 12.0#
        End If

        NewFpsRender = 1.0# / NewTimeRender
        Smoot_value(OldFpsRender, NewFpsRender)
        If OldFpsRender > 9999 Then OldFpsRender = 9999

        delta = NewTimePhysics - OldTimePhysics
        If System.Math.Abs(delta) > 0.1 Then
            OldTimePhysics = NewTimePhysics
        Else
            OldTimePhysics += delta / 12.0#
        End If

        delta = NewTimeTotal - OldTimeTotal
        If System.Math.Abs(delta) > 0.1 Then
            OldTimeTotal = NewTimeTotal
        Else
            OldTimeTotal += delta / 12.0#
        End If

        delta = NewTimeLoop - OldTimeLoop
        If System.Math.Abs(delta) > 0.01 Then
            OldTimeLoop = NewTimeLoop
        Else
            OldTimeLoop += delta / 12.0#
        End If

        ' ------------------------------------------------------ calc and limit the FPS correction
        If OldTimeLoop > 0 Then k_FPS = CSng(1 / OldTimeLoop)
        If k_FPS < 3 Then k_FPS = 3
        If k_FPS > 30 Then k_FPS = 30
        k_FPS2 = k_FPS * k_FPS
        k_TIME = 1 / k_FPS
        'Debug.Print k_FPS
    End Sub

    Private Sub Smoot_value(ByRef value As Double, ByVal new_value As Double)
        '
        Dim delta As Double = new_value - value
        Dim delta_sgn As Double = Math.Sign(delta)
        Dim delta_abs As Double = Math.Abs(delta)
        '
        Dim delta_pow As Double
        delta_pow = (10 * delta_abs / (Math.Min(Math.Abs(new_value), (Math.Abs(value))))) ^ 2
        '
        If delta_pow >= delta_abs Then
            value = new_value
        Else
            value += delta_sgn * delta_pow
        End If
    End Sub

	
	' --------------------------------------------------------------------------- PRINT FPS
    Private Sub PrintFPS()
        Dim s1 As String
        If Bullet_Paused Then
            s1 = "Ph(paused) " & Int(OldTimePhysics * 1000) & " mS "
        ElseIf DEBUG_UseThreads Then
            s1 = "Ph(thread) " & Int(OldTimePhysics * 1000) & " mS "
        Else
            s1 = "   Physics " & Int(OldTimePhysics * 1000) & " mS "
        End If
        If s1 <> Form1.lbl_TimePhysics.Text Then Form1.lbl_TimePhysics.Text = s1

        s1 = "     Total " & Int(OldTimeRender * 1000) & " mS "
        If s1 <> Form1.lbl_TimeTotal.Text Then Form1.lbl_TimeTotal.Text = s1

        s1 = "       Fps " & Int(OldFpsRender) & " "
        If s1 <> Form1.lbl_Fps.Text Then Form1.lbl_Fps.Text = s1

        s1 = " Fps(stab) " & Int(1.0# / OldTimeLoop + 0.9) & " "
        If s1 <> Form1.lbl_FpsStab.Text Then Form1.lbl_FpsStab.Text = s1
    End Sub



    Friend Sub StartTimers()
        Form1.Timer1.Interval = 1
        Form1.Timer1.Start()
        'AsyncTimer_Start()
        'BulletThread.Start()
    End Sub
    Friend Sub StopTimers()
        Bullet_Thread_Stop
        Form1.Timer1.Stop()
        'AsyncTimer_Stop()
    End Sub





    ' ========================================================================================
    '   THIS TIMER WORKS ASYNC - IN A SEPARATE THREAD
    ' ========================================================================================
    ' ------------------------------------------------------------
    ' Timers.Timer
    ' ------------------------------------------------------------
    'Private WithEvents AsyncTimer As System.Timers.Timer

    'Private Sub AsyncTimer_Start()
    '    AsyncTimer = Nothing
    '    AsyncTimer = New System.Timers.Timer
    '    AsyncTimer.Interval = 30
    '    AsyncTimer.Start()
    'End Sub

    'Private Sub AsyncTimer_Stop()
    '    If Not AsyncTimer Is Nothing Then
    '        AsyncTimer.Stop()
    '    End If
    'End Sub

    'Private Sub AsyncTimer_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles AsyncTimer.Elapsed
    '    BulletDoStepSimulation(0.03)
    'End Sub


    ' ========================================================================================
    '   THIS TIMER WORKS SYNCRONOUSLY IN THE APPLICATION THREAD 
    ' ========================================================================================

    'Private WithEvents SyncTimer As System.Windows.Forms.Timer

    'Private Sub SyncTimer_Start()
    '    SyncTimer = Nothing
    '    SyncTimer = New System.Windows.Forms.Timer
    '    SyncTimer.Interval = 30
    '    SyncTimer.Start()
    'End Sub

    'Private Sub SyncTimer_Stop()
    '    If Not SyncTimer Is Nothing Then
    '        SyncTimer.Stop()
    '    End If
    'End Sub

    'Private Sub SyncTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles SyncTimer.Tick
    '    BulletDoStepSimulation(0.03)
    'End Sub



End Module